name = 'gas';
version = getWidgetVersion();

function getWidgetVersion()
{
	if(window.widget)
		return widget.system("/usr/bin/defaults read \"`pwd`/Info\" CFBundleVersion", null).outputString;
}

//globals
var stationList = null;
var gradeList = new Array("regular", "plus", "premium", "diesel");
var gradesShown = new Array(true, true, false, false);
var gradeTimers = [[null, null, null],[null, null, null],[null, null, null],[null, null, null]];
var rankShown = 1;
var colorset = "classic";
var queryID = "";
var multiviewing = false;
var keystrokeCache = new Cache(1);
var tabFrom = "preferencesTab";
var clickCount = 0;
var tabIncrement = new Array("Preferences", "Gas Gauge", "Spotting", "Information");
var usedScroll = false;

//colors
var green  = "#66DD22";
var yellow = "#D8DE46";
var orange = "#FF9900";
var red    = "#FF3300";
var gray   = "#DDDDDD";
var currentColor = gray;

var tank;
var mpg;
var full;

//initialization function
function loaded()
{
	//buttons
	createGenericButton($('doneButton'), "<font color=black>Done</font>", showfrontside, 60);
	createGenericButton($('donateButton'), "<font color=black>Donate</font>", donate, 60);
	createGenericButton($('registerButton'), "<font color=black>Register</font>", register, 80);
	createGenericButton($('spotButton'), "<font color=black>Spot</font>", spot, 80);
	
	if(window.widget)
	{
	    prefsVersion = widget.preferenceForKey("version");
	    widget.setPreferenceForKey(version, "version");

	    zipcode = preferenceForKey("zipcode");
	    label = preferenceForKey("label");
	    radius = preferenceForKey("radius");
	    sortnum = preferenceForKey("sortnum");
	    pole = preferenceForKey("pole");
	    color = preferenceForKey("color");
	    colorset = preferenceForKey("colorset");
	    multigrade = preferenceForKey("multigrade");
    
		gradesShown[0] = preferenceForKey("regular"); 
	    gradesShown[1] = preferenceForKey("plus");
	    gradesShown[2] = preferenceForKey("premium");
	    gradesShown[3] = preferenceForKey("diesel");
    
	    tank = preferenceForKey("tank");
	    mpg = preferenceForKey("mpg");
	    full = preferenceForKey("full");

	    if(tank != undefined)
	    	$("tank").value = tank;
    	
	    if(mpg != undefined)
	    	$("mpg").value = mpg;
    
	    if(full != undefined)
	    {
	    	$("gas_slider").value = full;
	    }

		/*
	    username = preferenceForKey("username");
	    password = preferenceForKey("password");
    	
	    if(username != undefined)
	    	$("gpwUser").value = username;
    	
	    if(password != undefined)
	    	$("gpwPass").value = password;
		*/        
    
		if(pole && prefsVersion != undefined && prefsVersion == version)
	    {
	        $("polebox").checked = 1;
	        togglePole(pole);
		} else {
		    $("polebox").checked = 0;
		}
	
		$("colorbox").checked = (color) ? 1 : 0;
		toggleColor(color);
	
		if(colorset != undefined)
	    {
	    	for( i = 0; i < $("skin").length; i++) {
				if ($("skin").options[i].value == colorset)
					$("skin").options[i].selected = true;
			}
	        switchColorset(colorset);
	    }
    
	    if (zipcode != undefined)
	    	$("zipcode").value = zipcode;
    
	    if (label != undefined)
	    {
	    	$("labelfield").value = label;
	    	changeLabel(label);
	    }
	
		if (radius != undefined)
		{
			//convert old radius preference
			switch(radius*1) {
				case  5: radius = '4'; break;
				case 10: radius = '5'; break;
				case 15: 
				case 20: radius = '6';
			}
		
			for( i = 0; i < $("radius").length; i++) {
				if ($("radius").options[i].value == radius)
					$("radius").options[i].selected = true;
			}
		}

		if (sortnum != undefined)
		{
			for( i = 0; i < $("sortnum").length; i++)
			{
				if ($("sortnum").options[i].value == sortnum)
					$("sortnum").options[i].selected = true;
			}
			updateSortGrade();
		}
	
		$("multibox").checked = (multigrade) ? 1 : 0;
		toggleMultiView(multigrade);
	
		$("rankDown").style.display = 'none';
    }

    if(window.widget)
    {
    	widget.onshow = onshow;
    	widget.onhide = onhide;
    }
    
    preload();
    $("back").style.display = "none";
    window.onkeydown = keyDown;
    
    resize();
    spinPrice();
    
    //we need to fix this so the refresh happens appropriately
	checkForUpdate();
	setInterval("performQuery()",3600000);
	setInterval("checkforupdate()",86400000);
	//setTimeout("performQuery()", 10);
}

function preload(){
	$("hiddenDrilldown").src = "images/black/drilldown_over.png";
	$("hiddenDrilldown").src = "images/bold/drilldown_over.png";
	$("hiddenDrilldown").src = "images/classic/drilldown_over.png";
	$("hiddenDrilldown").src = "images/deep/drilldown_over.png";
	$("hiddenDrilldown").src = "images/white/drilldown_over.png";
	
	new Effect.toggle("gas_gaugeTab", 'appear');
	new Effect.toggle("spottingTab", 'appear');
	new Effect.toggle("informationTab", 'appear');
}

function onhide()
{
	stopGauge();
}

function onshow()
{
	if($("gas_gaugeTab").style.opacity == 1)
		startGauge();
	
	if(!stationList || stationList[0].name == "No results found.")
		performQuery();
}

// A little utilitarian function to find elements by ID within a predefined heirarchy
function getSubelementById(element, id)
{
	if(element.id == id)
		return element;
	
	var nodes = element.children;
	
	for(var i = 0; nodes &&  i < nodes.length; i++)
    {		
		var e = getSubelementById(nodes[i], id);
		if(e)
			return e;
	}
	return null;
}

function nextStation()
{
	if(!stationList) return;
	
	if(keystrokeCache.lookup("nS")) return;
	keystrokeCache.insert("nS", "nS", .1);

    if(rankShown == maxRank) return;
    stationList[rankShown++].display();
    
    if(rankShown >= maxRank){
        $("rankUp").style.display = 'none';
        rankShown = maxRank;
    }
    if(rankShown > 1)
        $("rankDown").style.display = 'block';
}

function prevStation()
{
	if(!stationList) return;	
	
	if(keystrokeCache.lookup("pS")) return;
	keystrokeCache.insert("pS", "pS", .1);

    if(rankShown == 1) return;
    stationList[--rankShown - 1].display();
    
    if(rankShown <= 1){
        $("rankDown").style.display = 'none';
        rankShown = 1;
    }
    if(rankShown < 9)
        $("rankUp").style.display = 'block';
}

function nextGrade()
{
	if(keystrokeCache.lookup("nG")) return;
	keystrokeCache.insert("nG", "nG", .1);

	var gradePopup = document.getElementById("sortnum");
	var prevIndex = gradePopup.selectedIndex;
	
	if(multiviewing)
	{
		for(var i = gradePopup.selectedIndex + 1; i <= 4; i++)
		{
			if(gradesShown[i-1])
			{
				gradePopup.selectedIndex = i;
				break;
			}
		}
	} else
		gradePopup.selectedIndex = Math.min(gradePopup.selectedIndex + 1, 4);
	
	if(prevIndex != gradePopup.selectedIndex)
	{
		updateSortGrade();
		stationList[rankShown-1].display();
	}
}

function prevGrade()
{
	if(keystrokeCache.lookup("pG")) return;
	keystrokeCache.insert("pG", "pG", .1);

	var gradePopup = document.getElementById("sortnum");
	var prevIndex = gradePopup.selectedIndex;

	if(multiviewing)
	{	
		for(var i = gradePopup.selectedIndex - 1; i >= 1; i--)
		{
			if(gradesShown[i-1])
			{
				gradePopup.selectedIndex = i;
				break;
			}
		}
	} else
		gradePopup.selectedIndex = Math.max(gradePopup.selectedIndex - 1, 1);

	if(prevIndex != gradePopup.selectedIndex)
	{
		updateSortGrade();
		stationList[rankShown-1].display();
	}
}

function drilldown(grade)
{
    if($('multibox').checked == true)
    {
        drilldownDIV = $(grade+"Drilldown");
        gradeDIV = $(grade);
    
        var i
        for(i = 0; i < 4; i++)
            if(grade == gradeList[i]) break;
    
        if(gradeDIV.style.display == "none")
        {
        	Effect.BlindDown(grade, {duration:.15});
			Effect.BlindUp(grade+"Drilldown", {duration:.15});
            drilldownDIV.style.background = "url('images/" + colorset + "/drilldown.png')";
            gradesShown[i] = true;
            setPreferenceForKey(gradesShown[i], gradeList[i]);
        } else {
            Effect.BlindUp(grade, {duration:.15});
            Effect.BlindDown(grade+"Drilldown", {duration:.15});
            gradesShown[i] = false;
            setPreferenceForKey(gradesShown[i], gradeList[i]);
        }
        resize();
    }
}

function drillOver(DIV)
{
    if($('multibox').checked == true)
        DIV.style.background = "url('images/" + colorset + "/drilldown_over.png')";
}

function drillOut(DIV)
{
    DIV.style.background = "url('images/" + colorset + "/drilldown.png')";
}

function showbackside()
{
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	resize();
	
	$("front").style.display="none";
	$("back").style.display="block";
	
	if($("gas_gaugeTab").style.opacity == 1)
		setTimeout("startGauge()", 750);
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	
}

function showfrontside() {

    var zipcode = $("zipcode").value;
	var radius = $("radius").value;
	var sortnum = $("sortnum").value;

    setPreferenceForKey(zipcode, "zipcode");
	setPreferenceForKey(radius, "radius");
	setPreferenceForKey(sortnum, "sortnum");
	
	stopGauge();
	
	if (window.widget)
		widget.prepareForTransition("ToFront")
	
	$("front").style.display = "block";
	$("back").style.display = "none";
	resize();
	
	if (window.widget)
	   setTimeout ('widget.performTransition();', 0);
}

function selectTab(tab){	
	var fadeDuration = .25;
	new Effect.toggle(tabFrom, 'appear', {duration:fadeDuration});
	tabID = (tab.toLowerCase() + 'Tab').replace(" ", "_");
	new Effect.toggle(tabID, 'appear', {duration:fadeDuration,from:0,to:1});
	tabFrom = (tab.toLowerCase() + 'Tab').replace(" ", "_");
	$('panelSelection').innerText = tab;
	tabID == "gas_gaugeTab" ? startGauge() : stopGauge();
	if(usedScroll == false){
		for(i=0;i<4;i++) {
			if($("panelSelector").options[i].value == tab){
				clickCount = i;
			}
		}
	}
	usedScroll = false;
}

function changeCSSRule(rule, style, value)
{
	var ss = document.styleSheets[0];
	var r = ss.cssRules;
	
	for(i=1; i<r.length; i++) {
		if(r[i].selectorText.toLowerCase() == rule.toLowerCase())
			eval("r[i].style." + style + " = '" + value + "';");
	}	
}

function toggleColor(on)
{
	if(on)
	{
		colorizeMe = 1;
		color = $("colorbox").checked;
		setPreferenceForKey(color, "color");
	}
	else
	{
		colorizeMe = 0;
		color = $("colorbox").checked;
		setPreferenceForKey(color, "color");
	}
}

function togglePole(on)
{
	if(on)
	{
		$('pole').style.display = 'block';
		pole = $("polebox").checked;
		setPreferenceForKey(pole, "pole");
		
		resize();
	}
	else
	{
		$('pole').style.display = 'none';
		pole = $("polebox").checked;
		setPreferenceForKey(pole, "pole");
		
		resize();
    }
}

function toggleMultiView(on)
{
    if(on)
    {
        grade = $("sortnum").selectedIndex - 1;
        multiviewing = true;
    
    	for(i=0;i<4;i++){
			if(gradesShown[i] == true){
				$(gradeList[i]).style.display = "block";
				$(gradeList[i]+"Drilldown").style.display = "none";
			}else{
				$(gradeList[i]).style.display = "none";
				$(gradeList[i]+"Drilldown").style.display = "block";
			}
    	}
        
        //$("gradeUp").style.display = "none";
        //$("gradeDown").style.display = "none";
        multigrade = $("multibox").checked;
        setPreferenceForKey(multigrade, "multigrade");
        
    }
    else
    {
    	multiviewing = false;
        grade = $("sortnum").selectedIndex - 1;
        
        for(var i = 0; i < 4; i++)
        {
            gradeDIV = $(gradeList[i]);
            $(gradeList[i] + "Drilldown").style.display = "none";
        
            if(i == grade)
            {
                gradesShown[i] = true;
                gradeDIV.style.display = "block";
            } else {
                gradesShown[i] = false;
                gradeDIV.style.display = "none";
            }
        }
        
        //$("gradeUp").style.display = "block";
        //$("gradeDown").style.display = "block";
        multigrade = $("multibox").checked;
        setPreferenceForKey(multigrade, "multigrade");
    }
    resize();
    performQuery();
}

//keyboard support
function keyDown(e)
{
    if(window.widget && $('front').style.display != 'none')
    {
        key = true;
        //alert(e.keyCode);
        
        switch(e.keyCode) {
                case 39:nextStation();break;
                case 37:prevStation();break;
                case 40:nextGrade(); break;
                case 38:prevGrade(); break;
                case 49:case 50:case 51:
                case 52:case 53:case 54:
                case 55:case 56:case 57:
                case 97:case 98:case 99:
                case 100:case 101:case 102:
                case 103:case 104:case 105:
                rankShown = 1 + e.keyCode - ((e.keyCode > 60) ? 97 : 49);
                rankShown = (rankShown > maxRank) ? maxRank : rankShown;
                
                $("rankDown").style.display = 'block';
                $("rankUp").style.display = 'block';
                
                if(rankShown == maxRank)
                    $("rankUp").style.display = 'none';
                else if(rankShown == 1)
                    $("rankDown").style.display = 'none';
                
                stationList[rankShown-1].display();
                break;
                
                default: key = false;
        }
        if(key) event.stopPropagation();
    }
}

//scrollwheel support
function mouseWheelMove(event) {
    var clicks = window.event.wheelDelta/360;
    clicks = (clicks > 0) ? Math.ceil(clicks) : Math.floor(clicks);

    if($("back").style.display == "none"){
   		rankShown += clicks
    	rankShown = (rankShown > maxRank) ? maxRank : rankShown;
    	rankShown = (rankShown < 1) ? 1 : rankShown;
		$("rankDown").style.display = 'block';
    	$("rankUp").style.display = 'block';            
    	
    	if(rankShown == maxRank) {
        	$("rankUp").style.display = 'none';
        } else if(rankShown <= 1) {
        	$("rankDown").style.display = 'none';
        }
		
		if(stationList[rankShown-1].display() <= 0) {
    		stationList[rankShown-1].display() = 1;
    	}
    	
    	spinPrice();
    	setTimeout(stationList[rankShown-1].display(), 100);
    
	 }else{
		clickCount -= clicks;
 
 		if(clickCount >= 0 && clickCount <= 3){
 			setTimeout("selectTab(tabIncrement[clickCount]);", 250);
 			$("panelSelector").options[clickCount].selected = true;
 		}
 
 		clickCount = (clickCount > 3) ? 3 : clickCount;
 		clickCount = (clickCount < 0) ? 0 : clickCount;
 		
 		usedScroll = true;
    }
}

function handleUpdateResponse()
{
	if(updateReq.readyState == 4 && updateReq.status == 200)
    {
    	latestVersion = updateReq.responseText;
		if(latestVersion)
		{
			if (version < latestVersion) {
				$('update').style.display = "block";
				$('update_version').innerText = "version " + latestVersion;
				resize();
			}
		}
	}
}

function checkForUpdate()
{
    updateReq = new XMLHttpRequest();
    url = "http://www.interdimensionmedia.com/widgets/widgetversion.php?widget=" + name;
	updateReq.open("GET", url, true);
	updateReq.onreadystatechange = handleUpdateResponse;
	updateReq.send(null);
}

function dismissUpdate(download){

    if(download == true && window.widget)
		widget.openURL('http://www.interdimensionmedia.com/widgets/?widget=gas');

    $('update').style.display = 'none';
}

function donate() {
    if(window.widget)
		widget.openURL('https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=imawebhog@aol.com&item_name=Gas%203.0%20Widget%20Donation');
	else
		window.open('https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=imawebhog@aol.com&item_name=Gas%203.0%20Widget%20Donation');
}

function register() {
	if(window.widget)
		widget.openURL('http://www.gaspricewatch.com/new/f-HowDoI.asp?U=b');
	else
		window.open('http://www.gaspricewatch.com/new/f-HowDoI.asp?U=b');
}

function spot() {
/*
	// Need hID!!!!
		
	gpwUser = $("gpwUser").value;
	gpwPass = $("gpwPass").value;
	
	spotRegular = $("spotRegular").value;
	spotPlus = $("spotPlus").value;
	spotPremium = $("spotPremium").value;
	spotDiesel = $("spotDiesel").value;
	
	spotReq = new XMLHttpRequest();
	spotReq.open("POST", 'http://www.gaspricewatch.com/new/f-UpdatePrices.asp', true);
//  THIS WORKS! --->	spotReq.send("hsPP=10&hstn1=Shell&hstr1=15401 W Sunset Blvd&Hspn1=vvrsh&hid1=47398&hR1=2.73&RTO1=y&hM1=2.97&MTO1=y&hP1=3.67&PTO1=y&hD1=9.99&DTO1=y&Reg1=2.69&Mdg1=2.79&Prm1=2.89&SpNm=j-bear&SpPs=neW29KL");
//  THIS WORKS! --->	spotReq.send("hsPP=10&hstn2=76&hstr2=15400 W Sunset Blvd&hid2=47399&Reg2=2.71&Mdg2=2.81&Prm2=2.91&SpNm=j-bear&SpPs=neW29KL");
	spotReq.send("hsPP=10&hid1="+hID+"&Reg1="+spotRegular+"&Mdg1="+spotPlus+"&Prm1="+spotPremium+"&Dsl1="+spotDiesel+"&SpNm="+gpwUser+"+&SpPs="+gpwPass);
*/

	if(window.widget)
		widget.openURL('http://www.gaspricewatch.com/new/default.asp?t=3');
	else
		window.open('http://www.gaspricewatch.com/new/default.asp?t=3');
}


//overrides for preference functions that preserve unique preferences for each instance of the widget

function setPreferenceForKey(pref, key)
{
	unique_key = widget.identifier + "-" + key;
	widget.setPreferenceForKey(pref, key);
	widget.setPreferenceForKey(pref, unique_key);
}

function preferenceForKey(key)
{
    unique_key = widget.identifier + "-" + key;
    unique_pref = widget.preferenceForKey(unique_key);
    
    if(unique_pref != null) return unique_pref;
    else return widget.preferenceForKey(key);
}


// Apple supplied animation tools.  ------------------------------------------------------

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = $('flip');			    						// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

function mouseexit (event)
{
	if (flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = $('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
	//$('gradeUp').style.opacity = animation.now;
	//$('gradeDown').style.opacity = animation.now;
	$('rankUp').style.opacity = animation.now;
	$('rankDown').style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}